Unit Unit5;

Interface

Uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, IDEMain, Vcl.StdCtrls,
  InspectorControls, ComponentInspector, Vcl.ExtCtrls, Vcl.CategoryButtons, FormDesigner,
  AdvPanel, ToolPanels, System.Actions, Vcl.ActnList;

Type
  TForm5 = Class(TForm)
    Panel1: TPanel;
    IDEPaletteButtons1: TIDEPaletteButtons;
    Splitter1: TSplitter;
    cbObjects: TIDEComponentComboBox;
    fObjectInspector: TIDEInspector;
    IDEEngine1: TIDEEngine;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ActionList1: TActionList;
    ActCopy: TAction;
    Button4: TButton;
    ActPaste: TAction;
    procedure ActCopyExecute(Sender: TObject);
    procedure ActCopyUpdate(Sender: TObject);
    procedure ActPasteExecute(Sender: TObject);
    procedure ActPasteUpdate(Sender: TObject);
    Procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  Private
    { Dclarations prives }
    FDesigner: TIDEFormDesigner;
  Public
    { Dclarations publiques }
  End;

Var
  Form5: TForm5;

Implementation

{$R *.dfm}

procedure TForm5.ActCopyExecute(Sender: TObject);
begin
FDesigner.CopyToClipboard;
end;

procedure TForm5.ActCopyUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (FDesigner <> nil) and (FDesigner.CanCopy);
end;

procedure TForm5.ActPasteExecute(Sender: TObject);
begin
FDesigner.PasteFromClipboard;
end;

procedure TForm5.ActPasteUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (FDesigner <> nil) and (FDesigner.CanPaste);
end;

Procedure TForm5.Button1Click(Sender: TObject);
Begin
      If FDesigner <> Nil Then
        Begin
          FDesigner.Active := False;
          FreeAndNil(FDesigner);
        End;

  FDesigner := TIDEFormDesigner.Create(Self);
  IDEEngine1.FormDesigner := FDesigner;
  IDEEngine1.Inspector := fObjectInspector;
  IDEEngine1.ComponentCombo := cbObjects;
  IDEEngine1.PaletteButtons := IDEPaletteButtons1;
  IDEEngine1.PreventDefaultEventCreation := True;
  FDesigner.ShowNonVisual := False;


  FDesigner.LockChildren := cmRecurse;
  FDesigner.ProtectedControls.Add('Panel1');
  FDesigner.LockedControls.Add('Button1');
  FDesigner.LockedControls.Add('Button2');
  FDesigner.LockedControls.Add('Button3');
  FDesigner.LockedControls.Add('Button4');

  FDesigner.ProtectChildren := cmRecurse;
  FDesigner.ProtectedControls.Add('Panel1');
  FDesigner.ProtectedControls.Add('Button1');
  FDesigner.ProtectedControls.Add('Button2');
  FDesigner.ProtectedControls.Add('Button3');
  FDesigner.ProtectedControls.Add('Button4');

  FDesigner.AlignmentPalette := [apAutoShow, apStayOnTop, apShowHints, apFlatButtons];
  FDesigner.Active := true;
  FDesigner.HideAlignmentPalette;
End;

procedure TForm5.Button2Click(Sender: TObject);
begin
 FDesigner.Active := False;
 If FDesigner <> Nil Then
        Begin
          FDesigner.Active := False;
          FreeAndNil(FDesigner);
        End;
end;

procedure TForm5.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
If FDesigner <> Nil Then
        Begin
          FDesigner.Active := False;
          FreeAndNil(FDesigner);
        End;
end;

End.

